
          %-------------------%
\chapter{~~General description}\label{\numb section 1}
          %-------------------%

This section is a quick tour through \maniFEM's capabilities.
There is also a gallery with several examples at
{\small\tt https://maniFEM.rd.ciencias.ulisboa.pt/gallery/}


          %---------------------%
\section{~~An elementary example}\label{\numb section 1.\numb parag 1}
          %---------------------%

In this paragraph, we show how to build a rectangular mesh immersed in $ \mathbb{R}^3 $ 
and then compute the integral of two given functions.
Paragraph \ref{\numb section 1.\numb parag 4} shows a purely two-dimensional example.

\begin{figure} \centering
  \psfrag{SW}{\small\tt\textcolor{textindraw}{SW}}
  \psfrag{NW}{\small\tt\textcolor{textindraw}{NW}}
  \psfrag{SE}{\small\tt\textcolor{textindraw}{SE}}
  \psfrag{NE}{\small\tt\textcolor{textindraw}{NE}}
  \includegraphics[width=110mm]{3d-rectangle}
  \caption{a twisted rectangular mesh}
  \label{\numb section 1.\numb fig 1}
\end{figure}

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 1.\numb parag 1}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                            ]
#include \verde{"maniFEM.h"}

using namespace \verm{maniFEM};
using namespace std;

int main ()

\{  \cinza{// we choose our (geometric) space dimension :}
   \verm{Manifold} \azul{RR3} ( \taag::Euclid, \taag::of_dim, \laranja{3} );
   
   \cinza{// xyz is a map defined on our future mesh with values in RR3 :}
   \verm{Function} \azul{xyz} = RR3 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );

   \cinza{// we can extract components of xyz using the [] operator}
   \verm{Function} \azul{x} = xyz[\laranja{0}], \azul{y} = xyz[\laranja{1}], \azul{z} = xyz[\laranja{2}];

   \cinza{// Let's build a rectangular mesh. First, the four corners :}
   \verm{Cell} \azul{SW} ( \taag::vertex );  x(SW) = \laranja{-1.};  y(SW) = \laranja{0.};  z(SW) = \laranja{0.};
   \verm{Cell} \azul{SE} ( \taag::vertex );  x(SE) =  \laranja{1.};  y(SE) = \laranja{0.};  z(SE) = \laranja{0.};
   \verm{Cell} \azul{NE} ( \taag::vertex );  x(NE) =  \laranja{1.};  y(NE) = \laranja{1.};  z(NE) = \laranja{0.};
   \verm{Cell} \azul{NW} ( \taag::vertex );  x(NW) = \laranja{-1.};  y(NW) = \laranja{1.};  z(NW) = \laranja{1.};
   \cinza{// alternative syntax for declaring vertices :}
   \cinza{// Cell SW ( tag::vertex, tag::of_coords, \{ -1., 0., 0. \} )}
   \cinza{// Cell SE ( tag::vertex, tag::of_coords, \{  1., 0., 0. \} )}
   \cinza{// Cell NE ( tag::vertex, tag::of_coords, \{  1., 1., 0. \} )}
   \cinza{// Cell NW ( tag::vertex, tag::of_coords, \{ -1., 1., 1. \} )}
   
   \cinza{// we access the coordinates of a point using the () operator :}
   cout << \verde{"coordinates of NW : "} << x(NW) << \verde{" "} << y(NW) << \verde{" "} << z(NW) << endl;

   \cinza{// now build the four sides of the rectangle :}
   \verm{Mesh} \azul{south} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
                                          .start_at ( SW )
                                          .stop_at ( SE )
                                          .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{east} =  \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
                                          .start_at ( SE )
                                          .stop_at ( NE )
                                          .divided_in ( \laranja{10} );
   \cinza{// calls to methods of Mesh::Build can be chained on the same line :}
   \verm{Mesh} \azul{north} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( NE ) .stop_at ( NW ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{west} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( NW ) .stop_at ( SW ) .divided_in ( \laranja{10} );
   
   \cinza{// and now the rectangle :}
   \verm{Mesh} \azul{rect_mesh} = \verm{Mesh}::Build ( \taag::grid )
      .shape ( \taag::rectangle ) .faces ( south, east, north, west );

   \cinza{// we may want to visualize the resulting mesh}
   \cinza{// here is one way to export the mesh in the "msh" format :}
   rect_mesh .export_to_file ( \taag::gmsh, \verde{"rectangle.msh"} );

   \cinza{// let's define two symbolic functions}
   \verm{Function} \azul{f} = x*x + \laranja{1}/(\laranja{5}+y), \azul{g} = x*y;

   \cinza{// -------- code below depends on the MANIFEM_NO_FEM compilation flag ----------}
   \cinza{// -------- and on the Eigen library ------------ see paragraph 12.15 ----------}

   \cinza{// and compute their integral on the rectangle,}
   \cinza{// using, in each rectangular cell, Gauss quadrature with 9 points :}
   \verm{Integrator} \azul{integr} ( \taag::Gauss, \taag::quad_9 );

   cout << \verde{"integral of f "} << integr ( f, \taag::on, rect_mesh ) << endl;
   cout << \verde{"integral of g "} << integr ( g, \taag::on, rect_mesh ) << endl;

\}  \cinza{// end of main}
\end{Verbatim}

Paragraph \ref{\numb section 12.\numb parag 2} explains the coloring conventions observed
in this manual for {\tt C++} code.

To run this example, you will need a recent {\tt C++} compiler and the {\tt make} utility.
Visit {\small\tt https://codeberg.org/cristian.barbarosie/maniFEM}, choose a release
and download all files to some directory in your computer.
This manual describes release \manifemrelease.
Paragraph \ref{\numb section 12.\numb parag 15} gives more details.
% Latest code may be unstable, releases are stable.
Launch the program through the command
{\small\tt make run-parag-\ref{\numb section 1.\numb parag 1}};
a file {\small\tt rectangle.msh} should appear in the working directory.
You may view the mesh using the software {\small\tt gmsh}.

Expressions like {\small\tt\taag::of\_\,dim} and
{\small\tt\taag::vertex} are
objects belonging to the {\small\tt namespace} {\small\tt\verm{tag}};
we use them as arguments to many functions.
See paragraph \ref{\numb section 12.\numb parag 3} for some details.

Paragraph \ref{\numb section 6.\numb parag 1} explains why we build {\small\tt\verm{Function}}
{\small\tt\azul{xyz}} with arguments {\small\tt\taag::Lagrange,}\hfil\break
{\small\tt\taag::of\_\,degree,} {\small\tt\laranja{1}}.

In the above code, we declare a (segment or rectangle) {\small\tt\verm{Mesh}} by means of
a {\small\tt\verm{Mesh}::Build} object.
The argument {\small\tt\taag::grid} informs \maniFEM{} that we want a structured, regular mesh
(more details in section \ref{\numb section 2}).
Other types of mesh builders are declared 
with {\small\tt\taag::join} (used in paragraphs \ref{\numb section 1.\numb parag 4},
\ref{\numb section 1.\numb parag 5} and many others), with {\small\tt\taag::import\_\,from\_\,file}
(referred to in paragraph \ref{\numb section 1.\numb parag 4} and in section \ref{\numb section 5}),
with {\small\tt\taag::frontal}
(described paragraph \ref{\numb section 1.\numb parag 9} and in section \ref{\numb section 3}),
with {\small\tt\taag::extrude} (described in section \ref{\numb section 4})
and with {\small\tt\taag::gather} (described in section \ref{\numb section 5}).
An object declared as {\small\tt\verm{Mesh}::Build} {\small\tt(} {\small\tt\taag::grid} {\small\tt )}
accepts a call to method {\small\tt shape} which provides information on the actual shape of
the desired mesh.
Possible arguments of method {\small\tt\verm{Mesh}::Build::shape} are
{\small\tt\taag::segment}, {\small\tt\taag::rectangle}, {\small\tt\taag::triangle} and
{\small\tt\taag::cube}.
See also paragraph \ref{\numb section 12.\numb parag 8}.

The method {\small\tt\verm{Mesh}::Build::shape} returns another {\small\tt\verm{Mesh}::Build}
object whose behaviour depends on the provided argument.
A segment-shaped builder accepts subsequent calls to methods like
{\small\tt start\_\,at}, {\small\tt stop\_\,at} and  {\small\tt divided\_\,in},
while a rectangle-shaped builder accepts subsequent calls
to methods like {\small\tt faces} which provides the four sides.
Paragraph \ref{\numb section 1.\numb parag 4} explains why we build
the rectangle based on its four sides rather than on its four vertices.

Note that the segment meshes {\small\tt south}, {\small\tt east}, {\small\tt north} and
{\small\tt west} are embedded in straight lines within $ {\mathbb R}^3 $;
however, the two-dimensional mesh {\small\tt rect\_mesh} has a less clear geometry.
Since the provided sides are not coplanar,
the coordinates of the inner vertices are defined rather vaguely by interpolating the
coordinates of vertices on the boundary
(paragraph \ref{\numb section 13.\numb parag 2} gives details).
See sections \ref{\numb section 2} and \ref{\numb section 3} for ways to precisely define
a submanifold in $ \mathbb{R}^3 $ and mesh (a bounded region of) it.

More complex uses of the method {\small\tt\verm{Mesh}::export\_\,to\_\,file} are described in
paragraph \ref{\numb section 2.\numb parag 3}, section \ref{\numb section 5},
paragraphs \ref{\numb section 6.\numb parag 3} and \ref{\numb section 6.\numb parag 4}.


          %----------------%
\section{~~Cells and meshes}\label{\numb section 1.\numb parag 2}
          %----------------%

In \maniFEM, all basic constituents of meshes are called ``cells''. 
Points are zero-dimensional cells, segments are one-dimensional cells, triangles are
two-dimensional cells, and so on.

Roughly speaking, a mesh is a collection of cells of the same dimension. 
For efficiency reasons, meshes keep lists of cells of lower dimension, too. 
For instance, the mesh built in paragraph \ref{\numb section 1.\numb parag 1} is 
roughly a list of two-dimensional cells (quadrilaterals), but lists of segments and points
are also kept.
This represents quite some amount of redundant information, but it is useful e.g.\ for
quickly sweeping over all vertices of a mesh.%
\footnote {{} Actually, the implementation details are more complicated.
There are different kinds of meshes, some of them keep more information (lists of cells)
and are faster; others are slower but lighter in terms of memory occupied.
See e.g. paragraph \ref{\numb section 12.\numb parag 6}.}

A cell of dimension $ d>0 $ is defined by its boundary, 
which in turn is a mesh of dimension $ d-1 $. 
The boundary of a segment is a (zero-dimensional) mesh made of two points.
The boundary of a triangle is a one-dimensional mesh made of three segments.
Thus, a segment is essentially a pair of points, a triangle is essentially a triplet of segments, and so on.

Cells and meshes are oriented. 
An orientation of a mesh is just an orientation for each of its component cells;
these orientations must be mutually compatible.
Although this is not how the orientation is implemented internally
(see paragraph \ref{\numb section 12.\numb parag 4}),
an oriented point can be conceived simply as a point with a sign attached (1 or -1). 
The orientation of a cell of dimension higher than zero is given by an orientation
of its boundary, which is a lower-dimensional mesh.

Thus, an oriented segment is essentially a pair of points, one of which has a \hbox{-1}
attached, the other having a 1.
We call the former ``base'' and the latter ``tip''.
These signs are related to integration of functions along that segment.
The integral of a function of one variable is equal to the value of the 
primitive function at one end of the segment minus the value of the primitive at the other end.

An oriented triangle is essentially a triplet of segments, each one with its own orientation.
The orientations must be compatible to each other in the sense that each vertex 
must be seen as positive by one of the segments and as negative by another one.
An oriented tetrahedron can be identified with four triangles, each one with its own
orientation.
In such a tetrahedron, each segment must be seen as positive by one of the triangles and
as negative by another one.

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \includegraphics[width=130mm]{oriented-cells.eps}
  \caption{oriented segment, oriented pentagon}
  \label{\numb section 1.\numb fig 2}
\end{figure}

We can think of an oriented segment as an arrow pointing from its negative extremity (base)
towards its positive extremity (tip).
We can think of an oriented polygon as having an arrow attached to each of it sides,
or we can imagine a small oriented circle inside the polygon.

\begin{figure}[ht] \centering
  \includegraphics[width=140mm]{hemisphere-7}
  \caption{oriented meshes of dimension one and two}
  \label{\numb section 1.\numb fig 3}
\end{figure}

A one-dimensional oriented mesh can be thought of as a chain of arrows,
each one pointing to the next segment's base (like in figure \ref{\numb section 1.\numb fig 3}
left).
A two-dimensional oriented triangular mesh can be thought of as a web of triangles,
each triangle having a small oriented circle inside (like in figure
\ref{\numb section 1.\numb fig 3} right).
The orientations of neighbour cells must be compatible\,: each segment must be seen
in opposite orientations from the point of view of its two neighbour triangles.

The above description of the orientation of a two-dimensional mesh does not depend
on the surrounding space.
A mesh can be immersed in some Euclidian space $ \mathbb{R}^d $ or not.
As an extreme example, vertices may even have no coordinates at all.
However, in the case of a two-dimensional mesh immersed in $ \mathbb{R}^3 $,
the right hand rule establishes a correspondence between the oriented circle described above
and an arrow normal to the surface being meshed.
Note that the right hand rule is a convention based on the assuption that
the surrounding space $ \mathbb{R}^3 $ has a certain orientation.

Note also that an orientation of a mesh defines an orientation of its boundary.
In figure \ref{\numb section 1.\numb fig 3} (right) we can see the orientation of the
boundary of the mesh, shown with pink arrows.
This convention is used by Stokes' theorem.

Figure \ref{\numb section 1.\numb fig 4} shows two opposite orientations of a mesh,
together with the corresponding orientation of its boundary.

\begin{figure}[ht] \centering
\begin{subfigure}{72mm}\centering
  \includegraphics[width=70mm]{oriented-annulus-1}
\end{subfigure}  
\begin{subfigure}{72mm}\centering
  \includegraphics[width=70mm]{oriented-annulus-2}
\end{subfigure}  
  \caption{mesh with two opposite orientations}
  \label{\numb section 1.\numb fig 4}
\end{figure}

Often, when building a {\small\tt\verm{Mesh}}, {\maniFEM} chooses the orientation based
on the orientation of the boundary, as provided by the user.
For instance, in a statement like

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Mesh} \azul{rect_mesh} = \verm{Mesh}::Build ( \taag::grid )
      .shape ( \taag::rectangle ) .faces ( south, east, north, west );
\end{Verbatim}
\vskip 5pt

\noindent (used in paragraphs \ref{\numb section 1.\numb parag 1},
\ref{\numb section 1.\numb parag 4} and many others)
the orientation of {\small\tt\azul{rect\_\,mesh}} is defined by the orientation of
its four sides (which must be mutually compatible).
If we switch all four orientations, we will obtain the same mesh with the opposite orientation.
This can be done either by changing the declaration of each side (switching the first vertex with
the last) or by replacing (in the above declaration of {\small\tt\azul{rect\_\,mesh}})
{\small\tt south} by {\small\tt south} {\small\tt .reverse()},
{\small\tt east} by {\small\tt east.} {\small\tt .reverse()} and so on.
The {\small\tt reverse} method is explained below.
If we switch the orientation of one side only, {\maniFEM} will complain that
the orientations are not compatible with each other.

In paragraphs \ref{\numb section 1.\numb parag 4} and \ref{\numb section 3.\numb parag 18},
special attention is given to the orientation of the common boundary of meshes to be
subsequently joined.
In frontal mesh generation (described in section \ref{\numb section 3}) we often
provide the boundary of the future mesh, whose orientation determines the output of the
algorithm.
See also paragraph \ref{\numb section 10.\numb parag 5}.

{\ManiFEM} distinguishes between cells (which are geometric entities) and finite elements.
We may have different finite elements whose geometry is the same.
For instance, there are triangular Lagrange finite elemens of different degrees;
they will all dock on the same triangular cell.
Paragraph \ref{\numb section 11.\numb parag 1} gives more details.

Cells have a {\small\tt reverse} method returning the reversed cell.
Segment {\small\tt\verm{Cell}}\hglue0.5pt s have methods {\small\tt base} and {\small\tt tip}
returning their extremities.
For instance\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Cell} \azul{A} ( \taag::vertex );  \verm{Cell} \azul{B} ( \taag::vertex );
   assert ( A .is_positive() );
   assert ( not A .reverse() .is_positive() );
   assert ( A .reverse() .reverse() == A );
   \verm{Cell} \azul{AB} ( \taag::segment, A .reverse(), B );  \cinza{// here, AB is a segment Cell, not a Mesh}
   assert ( AB .base() == A .reverse() );
   assert ( AB .tip() == B );
   \verm{Cell} \azul{BA} = AB .reverse();
   assert ( BA .base() == B .reverse() );
   assert ( BA .tip() == A );
   assert ( BA .reverse() == AB );
\end{Verbatim}

Paragraph \ref{\numb section 9.\numb parag 7} gives more details about the orientation of cells.
See also paragraph \ref{\numb section 12.\numb parag 4}.

Cells are topological entities; they carry no geometric information.
In particular, points do not have coordinates.
Coordinates are stored (semi-)externally, see paragraphs \ref{\numb section 6.\numb parag 1} and
\ref{\numb section 14.\numb parag 7}.

{\small\tt \verm{Mesh}}\hglue0.5pt es have a {\small\tt reverse} method, too.
It is used mainly when we want to {\small\tt join} meshes having a common piece of boundary;
see paragraphs \ref{\numb section 1.\numb parag 4}, \ref{\numb section 2.\numb parag 1},
\ref{\numb section 2.\numb parag 8},
\ref{\numb section 2.\numb parag 9}, \ref{\numb section 2.\numb parag 16},
\ref{\numb section 3.\numb parag 18}, \ref{\numb section 3.\numb parag 19},
\ref{\numb section 3.\numb parag 24}, \ref{\numb section 7.\numb parag 9}.

Below we show a low-level way of building a tiny mesh, made of two triangles only.
We stress that there are shorter and more elegant mesh constructors, see paragraphs
\ref{\numb section 1.\numb parag 1}, \ref{\numb section 1.\numb parag 4}\,--\,%
\ref{\numb section 1.\numb parag 6}, sections \ref{\numb section 2}\,--\,\ref{\numb section 4}.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Cell} \azul{C} ( \taag::vertex );
   \verm{Cell} \azul{BC} ( \taag::segment, B .reverse(), C );
   \verm{Cell} \azul{CA} ( \taag::segment, C .reverse(), A );
   \verm{Cell} \azul{ABC} ( \taag::triangle, AB, BC, CA );
   \verm{Cell} \azul{D} ( \taag::vertex );
   \verm{Cell} \azul{AD} ( \taag::segment, A .reverse(), D );
   \verm{Cell} \azul{DB} ( \taag::segment, D .reverse(), B );
   \verm{Cell} \azul{BAD} ( \taag::triangle, AB .reverse(), AD, DB );
   \verm{Mesh} \azul{msh} ( \taag::fuzzy, \taag::of_dim, \laranja{2} );
   ABC .add_to ( msh );
   BAD .add_to ( msh );
\end{Verbatim}


          %---------%
\section{~~Functions}\label{\numb section 1.\numb parag 3}
          %---------%

Minimalist programs like the pieces of code presented at the end of paragraph
\ref{\numb section 1.\numb parag 2} (consisting mainly of manipulation of
{\small\tt\verm{Cell}}\hglue0.5pt s) work without declaring a {\small\tt\verm{Manifold}}
and without {\small\tt\verm{Function}}\hglue0.5pt s.
However, most {\small\tt\verm{Mesh}::Build}\,ers will try to interpolate
geometric coordinates (which are {\small\tt\verm{Function}}\hglue0.5pt s)
based on the shape of the current {\small\tt\verm{Manifold}}.

{\small\tt\verm{Function}}\hglue0.5pt s in {\maniFEM} can be divided roughly in two categories.
Some keep numeric values, like {\small\tt x}, {\small\tt y} and {\small\tt z}
encountered in many places in this manual.
After building a function like

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Function} \azul{xyz} = RR3 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
\end{Verbatim}

\noindent the process of creating a new vertex will change.
For each new vertex, space in the computer's memory will be reserved for {\small\tt d} values of type
{\small\tt double} ({\small\tt d} being the dimension of the {\small\tt\verm{Manifold}},
here {\small\tt RR3}).
The components of {\small\tt xyz} can be extracted like in

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Function} \azul{x} = xyz[\laranja{0}], \azul{y} = xyz[\laranja{1}], \azul{z} = xyz[\laranja{2}];
\end{Verbatim}

\noindent They are mere handlers through which we access the above referred \ {\small\tt double}
\ values, like in {\small\tt x(A)} {\small\tt =} {\small\tt \laranja{1.}}\ or
{\small\tt double} {\small\tt \azul{sum}} {\small\tt =} {\small\tt x(A)} {\small\tt +}
{\small\tt y(B)} {\small\tt +} {\small\tt z(C)}.
The interaction between the {\small\tt\verm{Function}} object and the values
associated to each vertex involves other layers, one of which is a {\small\tt Field}
object.

Other {\small\tt\verm{Function}}\hglue0.5pt s are not related with space in the computer's memory
(they have no subjacent {\small\tt Field}).
For instance, there are arithmetic expressions like 

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Function} \azul{norm} = \verm{power} ( x*x + y*y + z*z, \laranja{0.5} );
\end{Verbatim}

We can still access the value of such a {\small\tt\verm{Function}} at a cell like in
{\small\tt double} {\small\tt \azul{n}} {\small\tt =} {\small\tt norm(A)};
the computer will return the value of the corresponding arithmetic expression,
replacing the symbols {\small\tt x}, {\small\tt y} and {\small\tt z} by the corresponding
values at cell {\small\tt A}.
But it makes no sense to change the value of {\small\tt norm} at cell {\small\tt A}.
Thus, statements like {\small\tt x(A)} {\small\tt =} {\small\tt\laranja{1.}} work fine,
while {\small\tt norm(A)} {\small\tt =} {\small\tt\laranja{1.}} produces a run-time error.

The method {\small\tt\verm{Function}::deriv} performs symbolic differentiation\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Function} \azul{d_norm_d_x} = norm .deriv (x);
   \verm{Function} \azul{d_norm_d_y} = norm .deriv (y);
\end{Verbatim}

Integrals of {\small\tt\verm{Function}}\hglue0.5pt s are computed by means of
{\small\tt\verm{Integrator}}\hglue0.5pt s, either alone or coupled with a {\small\tt\verm{FiniteElement}}.
Section \ref{\numb section 11} shows several examples.

Paragraph \ref{\numb section 6.\numb parag 1} gives more details on {\small\tt\verm{Function}}\hglue0.5pt s.


          %--------------%
\section{~~Joining meshes}\label{\numb section 1.\numb parag 4}
          %--------------%

The example in paragraph \ref{\numb section 1.\numb parag 1} could have been shortened
had we used the {\small\tt \verm{Mesh}::Build}\,er with
{\small\tt .shape} {\small\tt(} {\small\tt\taag::rectangle} {\small\tt)}
followed by a call to method {\small\tt vertices} which accepts four corners as arguments. 
However, we prefer to build meshes in a structured way, 
first corners, then sides and then the plane region. 
This has the advantage that one can build more complex meshes from simple components. 
For instance, one can build an L-shaped mesh by joining three rectangular meshes\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 1.\numb parag 4}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} \azul{RR2} ( \taag::Euclid, \taag::of_dim, \laranja{2} );
   \verm{Function} \azul{xy} = RR2 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \cinza{// in this example, we do not need to give names to the two components of xy}

   \verm{Cell} \azul{A} ( \taag::vertex, \taag::of_coords, \{ \laranja{-1.}, \laranja{0.}  \} );
   \verm{Cell} \azul{B} ( \taag::vertex, \taag::of_coords, \{  \laranja{0.}, \laranja{0.}  \} );
   \verm{Cell} \azul{C} ( \taag::vertex, \taag::of_coords, \{  \laranja{0.}, \laranja{0.5} \} );
   \verm{Cell} \azul{D} ( \taag::vertex, \taag::of_coords, \{ \laranja{-1.}, \laranja{0.5} \} );
   \verm{Cell} \azul{E} ( \taag::vertex, \taag::of_coords, \{  \laranja{0.}, \laranja{1.}  \} );
   \verm{Cell} \azul{F} ( \taag::vertex, \taag::of_coords, \{ \laranja{-1.}, \laranja{1.}  \} );
   \verm{Cell} \azul{G} ( \taag::vertex, \taag::of_coords, \{  \laranja{1.}, \laranja{0.}  \} );
   \verm{Cell} \azul{H} ( \taag::vertex, \taag::of_coords, \{  \laranja{1.}, \laranja{0.5} \} );

   \verm{Mesh} \azul{AB} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( A ) .stop_at ( B ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{BC} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( B ) .stop_at ( C ) .divided_in ( \laranja{8} );
   \verm{Mesh} \azul{CD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( C ) .stop_at ( D ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{DA} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( D ) .stop_at ( A ) .divided_in ( \laranja{8} );
   \verm{Mesh} \azul{CE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( C ) .stop_at ( E ) .divided_in ( \laranja{7} );
   \verm{Mesh} \azul{EF} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( E ) .stop_at ( F ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{FD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( F ) .stop_at ( D ) .divided_in ( \laranja{7} );
   \verm{Mesh} \azul{BG} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( B ) .stop_at ( G ) .divided_in ( \laranja{12} );
   \verm{Mesh} \azul{GH} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( G ) .stop_at ( H ) .divided_in ( \laranja{8} );
   \verm{Mesh} \azul{HC} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( H ) .stop_at ( C ) .divided_in ( \laranja{12} );

   \verm{Mesh} \azul{ABCD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::rectangle )
      .faces ( AB, BC, CD, DA );
   \verm{Mesh} \azul{CEFD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::rectangle )
      .faces ( CE, EF, FD, CD .reverse() );
   \verm{Mesh} \azul{BGHC} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::rectangle )
      .faces ( BG, GH, HC, BC .reverse() );

   \verm{Mesh} \azul{L_shaped} = \verm{Mesh}::Build ( \taag::join ) .meshes ( \{ ABCD, CEFD, BGHC \} );
   \cinza{// alternative syntax :}
   \cinza{// Mesh L_shaped = Mesh::Build ( tag::join )}
   \cinza{//    .mesh ( ABCD ) .mesh ( CEFD ) .mesh ( BGHC );}
\end{Verbatim}

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{F}{\small\tt\textcolor{textindraw}{F}}
  \psfrag{G}{\small\tt\textcolor{textindraw}{G}}
  \psfrag{H}{\small\tt\textcolor{textindraw}{H}}
  \includegraphics[width=95mm]{L-shaped}
  \caption{an L-shaped mesh}
  \label{\numb section 1.\numb fig 5}
\end{figure}

Meshes in $ \mathbb{R}^2 $ like the one above may be exported in the {\small\tt msh} format
or directly drawn in {\small\tt PostScript}, by one of the two statements below

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   L_shaped .export_to_file ( \taag::gmsh, \verde{"L-shaped.msh"} );
   L_shaped .export_to_file ( \taag::PostScript, \verde{"L-shaped.eps"} );
   \cinza{// tag::PostScript and tag::eps are interchangeable :}
   \cinza{// L_shaped .export_to_file ( tag::eps, "L-shaped.eps" )}
\end{Verbatim}

\begin{figure}[ht]  \centering
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \includegraphics[width=95mm]{L-crack}
  \caption{a zoom around {\small\tt C}}
  \label{\numb section 1.\numb fig 6}
\end{figure}

Note that, in \maniFEM, cells and meshes are oriented
(see paragraph \ref{\numb section 1.\numb parag 2}).
To build {\small\tt \azul{CEFD}} one must use not {\small\tt CD} but its reverse;
to build {\small\tt \azul{BGHC}} one must use not {\small\tt BC} but its reverse.
In figure \ref{\numb section 1.\numb fig 6} we see a zoom around {\small\tt C};
the three rectangular meshes have been separated just for visualization purposes.
The drawing illustrates that the common boundary has a certain orientation when seen
from one mesh and has the opposite orientation when seen from the neighbour mesh.
If we do not respect these orientations, {\maniFEM} will be unable to {\small\tt join}
these meshes.

We can imagine a magnet attached to each face of a cell.
For two neighbour cells, the common face will have two magnets, one from each cell.
If their polarities are not opposite, the magnets will not cling.
Likewise, the common boundary of two meshes that we intend to join can be thought of
as a pair of magnets.
If their polarities are not opposite, the two meshes will not cling.

When {\small\tt join}ing one-dimensional meshes, we use a slightly different convention\,:
it suffices that one mesh starts at the very point where the other ends.
In paragraph \ref{\numb section 2.\numb parag 1} we join {\small\tt HC} with {\small\tt CD};
this is possible because the mesh {\small\tt CD} starts at vertex {\small\tt C}
while {\small\tt CD} begins at the same vertex {\small\tt C}.
The same comments apply to one-dimensional meshes in paragraphs
\ref{\numb section 1.\numb parag 8}, \ref{\numb section 1.\numb parag 9},
\ref{\numb section 2.\numb parag 7}, \ref{\numb section 2.\numb parag 17},
\ref{\numb section 3.\numb parag 1} and \ref{\numb section 3.\numb parag 16}.

Note also that if we define the rectangles based on their vertices instead of their sides, 
the {\small\tt\verm{Mesh}::Build}\,er with {\small\tt \taag::join} will not work properly. 
\ManiFEM{} does provide a more compact way to define a rectangle, based on its four vertices\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Mesh} \azul{ABCD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::rectangle )
      .vertices ( A, B, C, D ) .divided_in ( \laranja{10}, \laranja{8} );
   \verm{Mesh} \azul{CEFD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::rectangle )
      .vertices ( C, E, F, D ) .divided_in ( \laranja{7}, \laranja{10} );
\end{Verbatim}

\noindent However, when the two rectangles above are meshed, the side {\small\tt CD} of {\small\tt ABCD}
is built independently (and unknowingly) of the side {\small\tt DC} of {\small\tt CEFD}.
Thus, these two rectangles cannot be joined.\,%
\footnote {{} Actually, they can be joined but the resulting mesh will have
a crack along {\footnotesize\tt CD} -- probably not what the user wants.}
The side {\small\tt CD} of {\small\tt ABCD} and the side {\small\tt DC} of {\small\tt CEFD}
are one-dimensional meshes both made of 10 segments but with different
interior points (only {\small\tt C} and {\small\tt D} are shared) and different segments.
In contrast, {\small\tt CD} and {\small\tt CD.reverse()} share the same 11 points and
the same 10 segments (reversed).
We encounter a similar problem when we try to {\small\tt join} extruded meshes,
as explained in paragraph \ref{\numb section 5.\numb parag 8}.

Paragraph \ref{\numb section 9.\numb parag 2} shows a more complex use of the
{\small\tt \verm{Mesh}::Build}\,er with {\small\tt \taag::join}.

Examples using the method {\small\tt\verm{Mesh}::Build::vertices}
are presented in paragraphs \ref{\numb section 1.\numb parag 10}, \ref{\numb section 2.\numb parag 23},
\ref{\numb section 10.\numb parag 1}\,--\,\ref{\numb section 10.\numb parag 3},
\ref{\numb section 11.\numb parag 2}, \ref{\numb section 11.\numb parag 4},
\ref{\numb section 11.\numb parag 6}\,--\,\ref{\numb section 11.\numb parag 8},
\ref{\numb section 11.\numb parag 10}.

Incidentally, note that a {\small\tt \verm{Mesh}::Build}\,er with
{\small\tt .shape} {\small\tt(} {\small\tt\taag::rectangle} {\small\tt)}
accepts any position of the four vertices. 
Thus, you can use it to build any quadrilateral; the inner vertices' coordinates are simply
interpolated from the coordinates of vertices on the boundary, as shown in paragraphs
\ref{\numb section 1.\numb parag 6} and \ref{\numb section 2.\numb parag 1}.
This can be done even in more than two (geometric) dimensions, like in
paragraphs \ref{\numb section 1.\numb parag 1}, \ref{\numb section 2.\numb parag 9},
\ref{\numb section 2.\numb parag 11}, \ref{\numb section 2.\numb parag 13} and
\ref{\numb section 2.\numb parag 14}.
Here, tags {\small\tt rectangle}, {\small\tt quadrilateral} and {\small\tt quadrangle}
can be used interchangeably.
Paragraph \ref{\numb section 13.\numb parag 2} provides technical details.

An almost identical mesh is built in paragraph \ref{\numb section 2.\numb parag 1}.

This is a good place to mention that {\maniFEM} can also import a mesh from a file
in {\small\tt msh} format\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Mesh} \azul{msh} = \verm{Mesh}::Build ( \taag::import_from_file )
      .format ( \taag::gmsh ) .file_name ( \verde{"filename.msh"} );
\end{Verbatim}

For geometric dimension higher than $3$, % or for meshes of topological dimension higher than $3$,
the {\small\tt msh} file exported with method {\small\tt\verm{Mesh}::export\_to\_file}
will not be readable by {\small\tt gmsh}.
However, it can still be used by \maniFEM{} to read back (import) the {\small\tt\verm{Mesh}} object,
as explained in paragraphs \ref{\numb section 5.\numb parag 1} and \ref{\numb section 5.\numb parag 2}.
\vfil\eject


          %-----------------%
\section{~~Triangular meshes}\label{\numb section 1.\numb parag 5}
          %-----------------%

We can also build meshes on triangular domains and {\small\tt join} them as we wish\,:

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \includegraphics[width=100mm]{three-tri}
  \caption{mesh obtained by {\small\tt join}ing three triangles}
  \label{\numb section 1.\numb fig 7}
\end{figure}

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 1.\numb parag 5}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Cell} \azul{A} ( \taag::vertex );  x(A) = \laranja{-1.} ;  y(A) = \laranja{0.};
   \verm{Cell} \azul{B} ( \taag::vertex );  x(B) =  \laranja{0.} ;  y(B) = \laranja{0.};
   \verm{Cell} \azul{C} ( \taag::vertex );  x(C) =  \laranja{1.} ;  y(C) = \laranja{0.};
   \verm{Cell} \azul{D} ( \taag::vertex );  x(D) = \laranja{-0.5};  y(D) = \laranja{1.};
   \verm{Cell} \azul{E} ( \taag::vertex );  x(E) =  \laranja{0.5};  y(E) = \laranja{1.};

   \verm{Mesh} \azul{AB} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( A ) .stop_at ( B ) .divided_in ( \laranja{8} );
   \verm{Mesh} \azul{BC} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( B ) .stop_at ( C ) .divided_in ( \laranja{8} );
   \verm{Mesh} \azul{AD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( A ) .stop_at ( D ) .divided_in ( \laranja{8} );
   \verm{Mesh} \azul{BD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( B ) .stop_at ( D ) .divided_in ( \laranja{8} );
   \verm{Mesh} \azul{BE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( B ) .stop_at ( E ) .divided_in ( \laranja{8} );
   \verm{Mesh} \azul{CE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( C ) .stop_at ( E ) .divided_in ( \laranja{8} );
   \verm{Mesh} \azul{ED} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( E ) .stop_at ( D ) .divided_in ( \laranja{8} );

   \verm{Mesh} \azul{ABD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::triangle )
      .faces ( AB, BD, AD .reverse() );
   \verm{Mesh} \azul{BCE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::triangle )
      .faces ( BC, CE, BE .reverse() );
   \verm{Mesh} \azul{BED} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::triangle )
      .faces ( BE, ED, BD .reverse() );

   \verm{Mesh} \azul{three_tri} = \verm{Mesh}::Build ( \taag::join ) .meshes ( \{ ABD, BCE, BED \} );
\end{Verbatim}
\vfil\eject


          %-------------------------------%
\section{~~Mixing triangles and rectangles}\label{\numb section 1.\numb parag 6}
          %-------------------------------%

It is possible to have triangles and quadrilaterals mixed in the same mesh\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 1.\numb parag 6}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Mesh} \azul{ABD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::triangle )
      .faces ( AB, BD, AD .reverse() );
   \verm{Mesh} \azul{BCE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::triangle )
      .faces ( BC, CE, BE .reverse() );
   \verm{Mesh} \azul{BEFD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::quadrangle )
      .faces ( BE, EF, FD, BD .reverse() );
   \verm{Mesh} \azul{mixed_mesh} = \verm{Mesh}::Build ( \taag::join ) .meshes ( \{ ABD, BEFD, BCE \} );
\end{Verbatim}
\vskip -2mm

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{F}{\small\tt\textcolor{textindraw}{F}}
  \includegraphics[width=110mm]{two-tri-one-rect}
  \caption{mixed mesh}
  \label{\numb section 1.\numb fig 8}
\end{figure}

The resulting mesh is shown in figure \ref{\numb section 1.\numb fig 8}.

Paragraphs \ref{\numb section 2.\numb parag 2}, \ref{\numb section 2.\numb parag 5},
\ref{\numb section 6.\numb parag 4} and \ref{\numb section 9.\numb parag 3}
show other examples of mixed meshes.


          %--------------%
\section{~~Meshing a cube}\label{\numb section 1.\numb parag 7}
          %--------------%

To build a mesh of cubic cells, we first build eight vertices, then twelve segments,
then six squares, then finally invoke a {\small\tt\verm{Mesh}::Build}\,er with
{\small\tt.shape} {\small\tt(} {\small\tt\taag::cube} {\small\tt)} (or, equivalently,
{\small\tt\taag::hexahedron})

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 1.\numb parag 7}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Mesh} \azul{cube} = \verm{Mesh}::Build ( tag::grid ) .shape ( \taag::cube )
      .faces ( ABCD, HGFE, BFGC, DHEA, CGHD, AEFB );
\end{Verbatim}

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{F}{\small\tt\textcolor{textindraw}{F}}
  \includegraphics[width=105mm]{cube-cut}
  \caption{mesh of cubes}
  \label{\numb section 1.\numb fig 9}
\end{figure}


Just like for two-dimensional rectangular meshes, the orientation of the resulting mesh is determined
by the orientation of the six faces, as provided by the user.
These orientations must be mutually compatible.

The order of the arguments of the above {\small\tt\verm{Mesh}::Build}\,er is not rigid;
the only constraint is that the first two meshes provided should be opposite faces of the cube,
just like the third and the fourth and the last two.

In figure \ref{\numb section 1.\numb fig 9}, some cells have been removed so that the reader
can see the inside of the cube.
This was done using the following options of {\small\tt gmsh}: {\small\tt Tools} $\to$
{\small\tt Clipping} $\to$ {\small\tt Mesh} $\to$ {\small\tt Planes} $\to$
{\small\tt Keep whole elements}, $ A = 1, B = -0.2, C = -0.3, D = 0.1 $.

Meshes made of cubes can be subsequently {\small\tt join}\hglue0.5pt ed to obtain more complex shapes;
paragraph \ref{\numb section 2.\numb parag 3} shows an example.

Just like for two-dimensional rectangular meshes, vertices may be in any position in the space,
the space may have more than three dimensions, edges and faces may be curved.
Paragraphs \ref{\numb section 2.\numb parag 15} and \ref{\numb section 2.\numb parag 18}
show fancier uses of the {\small\tt\verm{Mesh}::Build}\,er
with {\small\tt.shape} {\small\tt(} {\small\tt\taag::cube} {\small\tt)}.

An alternative method of meshing cubes (or hexahedra) is through extruding,
as explained in section \ref{\numb section 4}.


          %---------------------%
\section{~~Implicit submanifolds}\label{\numb section 1.\numb parag 8}
          %---------------------%

In \maniFEM{} one can define submanifolds of $ \mathbb{R}^d $ (typically $ d=2 $ or $ d=3 $).
Then, when constructing a {\small\tt\verm{Mesh}}, the newly build vertices will place
themselves along the current working manifold (the most recently declared
{\small\tt\verm{Manifold}}).

For instance, code below defines a circle in $ \mathbb{R}^2 $, of center $ (0.5,0.86) $
and radius $ 0.562339 $.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 1.\numb parag 8}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} \azul{RR2} ( \taag::Euclid, \taag::of_dim, \laranja{2} );
   \verm{Function} \azul{xy} = RR2 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{x} = xy[\laranja{0}], \azul{y} = xy[\laranja{1}];

   const double \azul{coef} = \laranja{0.7};
   const double \azul{r2} = (\laranja{1.}-\laranja{0.75}*coef)*(\laranja{1.}-\laranja{0.75}*coef) + \laranja{0.43}*\laranja{0.43}*coef*coef;
   \verm{Manifold} \azul{circle_1} = RR2 .implicit ( (x-\laranja{0.5})*(x-\laranja{0.5}) + (y-\laranja{0.86})*(y-\laranja{0.86}) == r2 );
\end{Verbatim}

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{F}{\small\tt\textcolor{textindraw}{F}}
  \includegraphics[width=68mm]{star-01}
  \caption{a star (union of six arcs of circle)}
  \label{\numb section 1.\numb fig 10}
\end{figure}

Note that {\small\tt circle\_1} is not a mesh.
It is an abstract object modelling a submanifold of $ \mathbb{R}^d $;
in this specific case, it models a closed curve in $ \mathbb{R}^2 $.

We next build two vertices and a segment {\small\tt\verm{Mesh}}.
While vertices {\small\tt A} and {\small\tt B} will not place themselves on {\small\tt circle\_1}
(unless we {\small\tt project} them explicitly),
all other vertices composing the mesh {\small\tt AB} will be placed on {\small\tt circle\_1}.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 1.\numb parag 8}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Cell} \azul{A} ( \taag::vertex );  x(A) = \laranja{0.75} * coef;  y(A) = \laranja{0.43} * coef;
   \verm{Cell} \azul{B} ( \taag::vertex );  x(B) = \laranja{0.};           y(B) = \laranja{0.86} * coef;
   \verm{Mesh} \azul{AB} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( A ) .stop_at ( B ) .divided_in ( \laranja{7} );
\end{Verbatim}

We repeat the above procedure to build six arcs of circle\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 1.\numb parag 8}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Cell} \azul{C} ( \taag::vertex );  x(C) = \laranja{-0.75} * coef;  y(C) = \laranja{0.43} * coef;
   \verm{Manifold} \azul{circle_2} = RR2 .implicit ( (x+\laranja{0.5})*(x+\laranja{0.5}) + (y-\laranja{0.86})*(y-\laranja{0.86}) == r2 );
   \verm{Mesh} \azul{BC} = \verm{Mesh}::Build ( tag::grid ) .shape ( \taag::segment )
      .start_at ( B ) .stop_at ( C ) .divided_in ( \laranja{7} );
   \cinza{// and so on ...}
\end{Verbatim}

By joining these six meshes we obtain the star-shaped closed curve drawn in figure 
\ref{\numb section 1.\numb fig 10}.

We could have used {\tt C++} loops, in the spirit of
paragraphs \ref{\numb section 9.\numb parag 2} -- \ref{\numb section 9.\numb parag 4}.

A mesh having the same star shape is built, by a different meshing procedure,
in paragraphs \ref{\numb section 1.\numb parag 9} and \ref{\numb section 7.\numb parag 21}
(in paragraph \ref{\numb section 7.\numb parag 21} it has opposite orientation).

Implicit manifolds are described in sections \ref{\numb section 2} and \ref{\numb section 3}.


          %-----------------------%
\section{~~Frontal mesh generation}\label{\numb section 1.\numb parag 9}
          %-----------------------%

\ManiFEM{} can build unstructured meshes by means of a {\small\tt\verm{Mesh}::Build}\,er
declared with {\small\tt\taag::frontal}.
Frontal mesh generation builds segments if the current working manifold has dimension one,
triangles if the manifold has dimension two, tetrahedra if the manifold has dimension three.

It should be stressed that this dimension is not necessarily equal to the number of coordinates.
For instance, in paragraph \ref{\numb section 1.\numb parag 8} each of the
{\small\tt circle}\hglue0.5pt s has (topological) dimension one, but each point
has two coordinates, that is, the geometric dimension is two.

In paragraph \ref{\numb section 1.\numb parag 8}, six arcs of circle are created;
each one is built by means of a mesh builder with {\small\tt .shape} {\small\tt(}
{\small\tt\taag::segment} {\small\tt)}.
This object simply builds a straight segment in the surrounding manifold {\small\tt RR2},
divides it in the desired number of segments cells and then projects its vertices
onto the current working manifold (the more recently declared manifold).
In contrast, frontal mesh generation, employed in the present paragraph, builds segment cells one by one,
following the shape of the current working manifold, until it meets the specified end point.
Rather than providing the number of divisions, we specify the desired length of the segments.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 1.\numb parag 9}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Mesh} \azul{AB} = \verm{Mesh}::Build ( \taag::frontal ) .desired_length ( \laranja{0.1} )
      .start_at ( A ) .towards ( \{ \laranja{-1.}, \laranja{0.} \} ) .stop_at ( B );
\end{Verbatim}

After building the six arcs of circle, we join them
(as already did in paragraph \ref{\numb section 1.\numb parag 8}).
Then we use again frontal mesh generation, this time aiming at triangles,
to fill the domain bounded by this closed curve (the union of the six arcs).
Since the topological dimension of the most recently declared {\small\tt\verm{Manifold}}
(which is {\small\tt circle\_\hglue 0.3pt 6}) is one,
we first change the current working manifold back to {\small\tt RR2};
thus, the frontal mesh generation algorithm will build triangles\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 1.\numb parag 9}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   RR2 .set_as_working_manifold();
\end{Verbatim}

The mesh generation process uses the mesh {\small\tt six\_\hglue 0.8 pt arcs} as starting point
(it will be the boundary of the meshed domain);
we provide it through the {\small\tt\verm{Mesh}::Build::boundary} method.
We also provide the approximate segment length in the produced mesh\,:
\medskip

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 1.\numb parag 9}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Mesh} \azul{star} = \verm{Mesh}::Build ( \taag::frontal ) .boundary ( six_arcs )
                                            .desired_length ( \laranja{0.1} );
\end{Verbatim}

Figure \ref{\numb section 1.\numb fig 11} shows the resulting mesh.

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{F}{\small\tt\textcolor{textindraw}{F}}
  \includegraphics[width=75mm]{star-02}
  \caption{a star, filled with triangles}
  \label{\numb section 1.\numb fig 11}
\end{figure}

We could have used the mesh built in paragraph \ref{\numb section 1.\numb parag 8} as starting point
(as boundary).

In paragraph \ref{\numb section 7.\numb parag 21},
a 1D mesh having the same star shape is built, with opposite orientation.
Starting from this mesh as boundary, a mesh of triangles is built on the perforated torus.

Frontal mesh generation is presented in detail in section \ref{\numb section 3}.


          %------------%
\section{~~Solving PDEs}\label{\numb section 1.\numb parag 10}
          %------------%

\ManiFEM{} can solve variational problems as shown below.
The user must declare a symbolic unknown function as well as a symbolic test function
before defining the variational formulation of the PDE to be solved.
\ManiFEM{} will choose the type of finite elements according to the geometry of the
cells and according to the degree chosen in the declaration of the unknown and test functions.

Code below only works if the compilation flag {\small\tt MANIFEM\_NO\_FEM} is de-activated
and the {\small\tt Eigen} library is installed;
paragraph \ref{\numb section 12.\numb parag 15} provides more details.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 1.\numb parag 10}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Mesh} \azul{bdry} = ...
   \verm{Mesh} \azul{domain} = ...

   \cinza{// we solve the elliptic equation}
   \cinza{//   - laplacian u = -4}
   \cinza{// whose exact solution is  x^2+y^2}
   \verm{Function} \azul{temperature}
      ( \taag::unknown, \taag::Lagrange, \taag::of_degree, \laranja{1}, \taag::mere_symbol );
   \verm{Function} \azul{phi} ( \taag::test, \taag::Lagrange, \taag::of_degree, \laranja{1}, \taag::mere_symbol );

   \verm{VariationalFormulation} \azul{Laplace} =
         (   temperature .deriv(x) * phi .deriv(x) \cinza{// +}
           + temperature .deriv(y) * phi .deriv(y) ) .integral_on ( domain )
      == \laranja{-4.} * phi .integral_on ( domain );

   Laplace .boundary_condition
      ( \taag::Dirichlet, temperature == x*x + y*y, \taag::on, bdry );
\end{Verbatim}

Figure \ref{\numb section 1.\numb fig 12} shows the level lines of the solution.

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{F}{\small\tt\textcolor{textindraw}{F}}
  \includegraphics[width=85mm]{triangle-Dirichlet}
  \caption{level lines of $ x^2+y^2 $ on a triangle, obtained by solving a PDE}
  \label{\numb section 1.\numb fig 12}
\end{figure}

More details on variational formulations are provided in section \ref{\numb section 6}.
\vfil\eject


          %------------------------------%
\section{~~Similar products (competitors)}\label{\numb section 1.\numb parag 11}
          %------------------------------%

deal.II\,: {\small\tt https://dealii.org/}

FEniCS/Dolphin\,: {\small\tt https://fenicsproject.org/}

FreeFem\,: {\small\tt https://freefem.org/}

GetFEM\,: {\small\tt https://getfem.org/}

gmsh\,: {\small\tt https://gmsh.info}

libMesh\,: {\small\tt https://libmesh.github.io/}

MFEM\,: {\small\tt https://mfem.org/}

Mmg PLATFORM\,: {\small\tt https://www.mmgtools.org}

OFELI\,: {\small\tt https://ofeli.org/}

PETSc-FEM\,: {\small\tt https://cimec.org.ar/foswiki/Main/Cimec/PETScFEM}

Pablo\,: {\small\tt https://optimad.github.io/PABLO/} (dedicated to octree meshing)

PolyFEM\,: {\small\tt https://github.com/polyfem/polyfem}

Rodin\,: {\small\tt https://github.com/cbritopacheco/rodin}


          %-------------%
\section{~~Strong points}\label{\numb section 1.\numb parag 12}
          %-------------%

{\ManiFEM} offers a flexible and general approach for defining meshes on manifolds
(sections \ref{\numb section 2} and \ref{\numb section 3}).
Meshes on quotient manifolds (section \ref{\numb section 7}) are handy for solving
problems with periodic boundary conditions.

One of the goals of {\maniFEM} is to make remeshing easy for end users.
Thus, meshes can be manipulated (cells can be added and removed) using intuitive commands
(section \ref{\numb section 10}).

In {\maniFEM}, the user defines finite elements using a clear and intuitive syntax
(section \ref{\numb section 11}).
Some types of finite elements are rather slow; they are interesting for dydactic purposes.
Fast versions are available; they use a slightly less elegant syntax.

The manual is clear and presents many examples.


          %-----------%
\section{~~Weak points}\label{\numb section 1.\numb parag 13}
          %-----------%

{\ManiFEM} is not intended for parallel processing (see paragraph \ref{\numb section 14.\numb parag 2}).

Some finite elements are slow (but fast versions are available).

Since {\maniFEM} is under heavy development, some features are still missing;
most notably, implemented finite elements are limited to Lagrange type.
See the changelog at the end of this manual (just before the index), especially the ``To do''
paragraph.

{\ManiFEM} relies on oriented cells and meshes.
Some people may find it confusing (the distinction between positive cells and negative cells).
